#include "ImagiBOT.h"
#include "ImagiBOT_Semaforo.h"

Semaforo::Semaforo(){
	pinMode(SemaforoRojo,OUTPUT);
	pinMode(SemaforoAmarillo,OUTPUT);
	pinMode(SemaforoVerde,OUTPUT);
	luzSemaforo=100;
}

RGB::RGB(){
	pinMode(RGBRojo,OUTPUT);
	pinMode(RGBVerde,OUTPUT);
	pinMode(RGBAzul,OUTPUT);
	int RojoActual=0;
  	int VerdeActual=0;
  	int AzulActual=0;
}
void RGB::Color(int Col){
	digitalWrite(RGBRojo,LOW);
	digitalWrite(RGBAzul,LOW);
	digitalWrite(RGBVerde,LOW);
	switch (Col){
		case 0: break;
		case 3: digitalWrite(RGBRojo,HIGH);break;//Rojo
		case 1: digitalWrite(RGBVerde,HIGH);break;//Verde
		case 5: digitalWrite(RGBAzul,HIGH);break;//Azul
		case 2: digitalWrite(RGBRojo,HIGH);digitalWrite(RGBVerde,HIGH);break;//Amarillo
		case 7: digitalWrite(RGBVerde,HIGH);digitalWrite(RGBAzul,HIGH);break;//Cian
		case 6: digitalWrite(RGBAzul,HIGH);digitalWrite(RGBRojo,HIGH);break;//Magenta
		case 8: digitalWrite(RGBVerde,HIGH);digitalWrite(RGBAzul,HIGH);digitalWrite(RGBRojo,HIGH);break;//Blanco
		default:
				digitalWrite(RGBRojo,HIGH);//Rojo
				digitalWrite(RGBVerde,HIGH);//Verde
				digitalWrite(RGBAzul,HIGH);break;//Azul
	}
}
void RGB::Aleatorio(){
	Color(random(1, 8));
}
void RGB::Colorea(int Rojo, int Verde, int Azul){
	RojoActual=Rojo;
	VerdeActual=Verde;
	AzulActual=Azul;
	analogWrite(RGBRojo,RojoActual);
	analogWrite(RGBVerde,VerdeActual);
	analogWrite(RGBAzul,AzulActual);
}

void RGB::Cambia(int Rojo, int Verde, int Azul){
	RojoDestino=Rojo;
	VerdeDestino=Verde;
	AzulDestino=Azul;
	RojoVariacion=(RojoActual-RojoDestino)/10;
	VerdeVariacion=(VerdeActual-VerdeDestino)/10;
  	AzulVariacion=(AzulActual-AzulDestino)/10; 
}

void RGB::Cambiando(){
	RojoActual += RojoVariacion;
	VerdeActual += VerdeVariacion;
	AzulActual += AzulVariacion;
	if(abs(RojoDestino-RojoActual)<2){RojoActual=RojoDestino;}
	if(abs(VerdeDestino-VerdeActual)<2){VerdeActual=VerdeDestino;}
	if(abs(AzulDestino-AzulActual)<2){AzulActual=AzulDestino;}
	analogWrite(RGBRojo,RojoActual);
	analogWrite(RGBVerde,VerdeActual);
	analogWrite(RGBAzul,AzulActual);
}

void Semaforo::Actualiza(){
		digitalWrite(SemaforoRojo,0);
	digitalWrite(SemaforoAmarillo,0);
	digitalWrite(SemaforoVerde,0);
	if(luzSemaforo==4){
		digitalWrite(SemaforoRojo,1);		
		digitalWrite(SemaforoAmarillo,1);
		digitalWrite(SemaforoVerde,1);
	}
	if(luzSemaforo==3){
		digitalWrite(SemaforoRojo,1);		
	}
	if(luzSemaforo==2){
		digitalWrite(SemaforoAmarillo,1);		
	}
	if(luzSemaforo==1){
		digitalWrite(SemaforoVerde,1);		
	}	
}
void Semaforo::Enciende(int Luz){
	luzSemaforo=Luz;

	Actualiza();
	/*if(Luz==4){
		digitalWrite(SemaforoRojo,1);		
		digitalWrite(SemaforoAmarillo,1);
		digitalWrite(SemaforoVerde,1);
	}
	if(Luz==3){
		digitalWrite(SemaforoRojo,1);		
	}
	if(Luz==2){
		digitalWrite(SemaforoAmarillo,1);		
	}
	if(Luz==1){
		digitalWrite(SemaforoVerde,1);		
	}*/

}

void Semaforo::Cambia(int Dir){
	luzSemaforo += Dir;
	if(luzSemaforo>3){luzSemaforo=1;}
	if(luzSemaforo<1){luzSemaforo=3;}
	Actualiza();
}

int Semaforo::obtenerSemaforo(){
	//luzSemaforo = luzSemaforo + 25;
	return luzSemaforo;
}

