#ifndef ImagiBOT_h
#define ImagiBOT_h

#include <Arduino.h>
#include "ImagiBOT_Buzzer.h"
#include "ImagiBOT_MatrizLed.h"
#include "ImagiBOT_Semaforo.h"
#include "ImagiBOT_Servo.h"
#include "ImagiBOT_Ultrasonico.h"
#include "ImagiBOT_LDR.h"
#include "ImagiBOT_Makey.h"
#include "ImagiBOT_IR.h"

	#define SemaforoRojo 13
	#define SemaforoAmarillo 12
	#define SemaforoVerde 11

	#define RGBRojo 13
	#define RGBVerde 11
	#define RGBAzul 12
	
	#define Servo180A 10
	#define Servo180B 9
	#define Servo180C 8
	#define Servo180D 7

	#define Servo360D 10
	#define Servo360I 9
	#define Servo360DD 8
	#define Servo360II 7

	#define UltrasonicoTriger 6
	#define UltrasonicoEcho 6

	#define MatrizLedDataIn 5
	#define MatrizLedClock 3
	#define MatrizLedLoad 4

	#define Proximidad1 A3
	#define Proximidad2 A4

	#define JostickX A2
	#define JostickY A1
	#define JostickPulsador A0

	#define LDRizq A6
	#define LDRder A5

	#define IRizq A3
	#define IRder A4

	#define Buzzer1 2

	#define Makey5 A4
	#define Makey4 A3
	#define Makey3 A2
	#define Makey2 A1
	#define Makey1 A0

#endif