#ifndef ImagiBOT_Servo_h
#define ImagiBOT_Servo_h
#include <Servo.h>

class Servo180
{
	public:
		void init();
		void Posicion(int Motor,int Pos, int Velocidad);
		void Simultaneo(int Pos0,int Pos1, int Pos2, int Pos3,int Duracion);
		int obtenerPosicion(int Motor);
	private:
		int PosicionActual[4];
};

class Servo360
{
	public:
		void init();
		void Velocidad(int Motor,int Vel, int Aceleracion);
		void Simultaneo(int VelDer,int VelIzq, int Duracion);
		void Aleatorio(int VelMin,int VelMax);
		void PegaLaVuelta(float Velocidad, float duracion);
		void SimultaneoLoop();
		int obtenerVelocidad(int Motor);
	private:
		int VelocidadActual[2];

};

float convierte(float Velocidad);

#endif